import { Provider, web3 } from '@coral-xyz/anchor';
import { Mint } from '@solana/spl-token-3.x';
export declare class MarinadeMint {
    private readonly anchorProvider;
    readonly address: web3.PublicKey;
    private constructor();
    static build(anchorProvider: Provider, mintAddress: web3.PublicKey): MarinadeMint;
    mintInfo: () => Promise<Mint>;
    /**
     * Returns Total supply as a number with decimals
     * @param mintInfoCached optional
     * @returns
     */
    totalSupply(mintInfoCached?: Mint): Promise<number>;
    /**
     * @deprecated use totalSupply() instead
     */
    tokenBalance(mintInfoCached?: Mint): Promise<number>;
}
