"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarinadeReferralPartnerState = void 0;
class MarinadeReferralPartnerState {
    constructor(state, referralStateAddress, marinadeReferralProgramId) {
        this.state = state;
        this.referralStateAddress = referralStateAddress;
        this.marinadeReferralProgramId = marinadeReferralProgramId;
    }
    static fetch(marinade, referralCode) {
        return __awaiter(this, void 0, void 0, function* () {
            const { marinadeReferralProgram, config } = marinade;
            const code = referralCode !== null && referralCode !== void 0 ? referralCode : config.referralCode;
            if (!code) {
                throw new Error('The Referral Code must be provided in the MarinadeConfigor supplied as an arg!');
            }
            const state = (yield marinadeReferralProgram.program.account.referralState.fetch(code));
            return new MarinadeReferralPartnerState(state, code, config.marinadeReferralProgramId);
        });
    }
}
exports.MarinadeReferralPartnerState = MarinadeReferralPartnerState;
//# sourceMappingURL=marinade-referral-partner-state.js.map