"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarinadePDA = void 0;
const anchor_1 = require("@coral-xyz/anchor");
class MarinadePDA {
    constructor(marinadeStateAddress, marinadeFinanceProgramId) {
        this.marinadeStateAddress = marinadeStateAddress;
        this.marinadeFinanceProgramId = marinadeFinanceProgramId;
        this.reserveAddress = () => __awaiter(this, void 0, void 0, function* () { return this.findProgramDerivedAddress("reserve" /* ProgramDerivedAddressSeed.RESERVE_ACCOUNT */); });
        this.mSolMintAuthority = () => __awaiter(this, void 0, void 0, function* () {
            return this.findProgramDerivedAddress("st_mint" /* ProgramDerivedAddressSeed.LIQ_POOL_MSOL_MINT_AUTHORITY */);
        });
        this.mSolLegAuthority = () => __awaiter(this, void 0, void 0, function* () {
            return this.findProgramDerivedAddress("liq_st_sol_authority" /* ProgramDerivedAddressSeed.LIQ_POOL_MSOL_AUTHORITY */);
        });
        this.lpMintAuthority = () => __awaiter(this, void 0, void 0, function* () {
            return this.findProgramDerivedAddress("liq_mint" /* ProgramDerivedAddressSeed.LIQ_POOL_MINT_AUTHORITY */);
        });
        this.solLeg = () => __awaiter(this, void 0, void 0, function* () {
            return this.findProgramDerivedAddress("liq_sol" /* ProgramDerivedAddressSeed.LIQ_POOL_SOL_ACCOUNT */);
        });
        this.stakeDepositAuthority = () => __awaiter(this, void 0, void 0, function* () { return this.findProgramDerivedAddress("deposit" /* ProgramDerivedAddressSeed.STAKE_DEPOSIT */); });
        this.stakeWithdrawAuthority = () => __awaiter(this, void 0, void 0, function* () { return this.findProgramDerivedAddress("withdraw" /* ProgramDerivedAddressSeed.STAKE_WITHDRAW */); });
    }
    findProgramDerivedAddress(seed, extraSeeds = []) {
        return __awaiter(this, void 0, void 0, function* () {
            const seeds = [
                this.marinadeStateAddress.toBuffer(),
                Buffer.from(seed),
                ...extraSeeds,
            ];
            const [result] = yield anchor_1.web3.PublicKey.findProgramAddress(seeds, this.marinadeFinanceProgramId);
            return result;
        });
    }
}
exports.MarinadePDA = MarinadePDA;
//# sourceMappingURL=marinade-state.pda.js.map