"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const globals_1 = require("@jest/globals");
const web3_js_1 = require("@solana/web3.js");
const bn_js_1 = __importDefault(require("bn.js"));
/**
 * Equality testers for jest to compare BN and PublicKey.
 */
globals_1.expect.addEqualityTesters([
    (a, b) => {
        if (a instanceof bn_js_1.default) {
            return a.eq(b);
        }
        return undefined;
    },
    (a, b) => {
        if (a instanceof web3_js_1.PublicKey) {
            return a.equals(b);
        }
        return undefined;
    },
]);
//# sourceMappingURL=equalityTesters.js.map